// **************************************************
// Datei: counter4.c, 07.10.08, Humer, WLAB 4N ******
// *** Zaehler mit Funktionen fuer 7Seg und Balken **
// *** Wertebereich 8 bit 0..255 ********************
// *** Taktquelle 10Hz - INT5 ************************
#include <reg517a.h>
unsigned int i;
bit flag;
char tab[16]={0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x90,
					0x88,0x83,0xA7,0xA1,0x86,0x8E};
unsigned char counter;  // Zaehlvariable
void init(void);		// initialisierung
void write7Seg(unsigned char SSeg); // Ausgabe 7Seg
void writeBalken(unsigned char Balken);// Ausgabe Balken
// *** Interruptfunktion fr 1 Hz ********************
void ZehnHZInterrupt (void) interrupt 12 // fr 10 Hz
{
	counter++;
	flag=1;
}
// Beginn Hauptprogramm *******************************
main()
{	
	init();
	while(1)
	{
			if(flag)
			{		
			write7Seg(counter%0x10); //Funktionsaufruf
			writeBalken(counter);	//Funktionsaufruf
			flag=0;
			}
	}
}
// Ende Hauptprogramm ********************************
void init(void)
{	P4=0;	// Rcksetzen Port4
	counter = 0; // Rcksetzen Variable counter
	EX5=1; // Freigabe INT1
	EAL=1; //Gen. Freigabe Interrupts
}
void write7Seg(unsigned char SSeg)
{		P6=P6&0x3F; // Balken und 7Seg sperren
		P6=P6|0x40; // 7Seg freigeben
		P4=tab[SSeg];// Tabelle indizieren und auslesen
		P6=P6&0x3F; // Balken und 7Seg sperren
}
void writeBalken(unsigned char Balken)
{
		P6=P6&0x3F; // Balken und 7Seg sperren
		P6=P6|0x80; // Balken freigeben
		P4=Balken;  // Ausgabe des Zaehlerstandes auf Balken
		P6=P6&0x3F; // Balken und 7Seg sperren
}